/*
  Pour des fins de tests...
  $Date: 2008-06-12 7:00 $
*/

domain {
   types { Place, Object, Truck }

   world {
      predicate visitable(Place);
      predicate link(Place,Place);
      numeric   distance(Place,Place);
   }

   state {
      function Place objectAt(Object);
      function Place robotAt();
      predicate visited(Place);
      numeric  travalDist();
   }


   action Goto(Place dest){
       duration:
       conditions:
          @start: visitable(dest);
          @start: robotAt() == robotAt();
       effects:
          @end: robotAt() = dest;
          @end: visited(dest);
   }

   action Take(Object o){
       duration:
       conditions:
          @start: objectAt(o) == robotAt();
       effects:
   }

   action Merge(Object o, Object o){
       duration:
       conditions:
       effects:
          @end: objectAt(o) = robotAt();
   }

   task Pickup(Place place, Object o){
      method m1(){
         a1: Goto(place);
         a2: Take(o);
      }[a1<a2;]
      method m2(Place inter){
         a0: Goto(inter);
         a1: Goto(place);
         a2: Take(o);
      }[a0<a1;a1<a2;]
   }

}
