
domain {
   types { Location, Object, Truck }

   world {
      predicate Link(Location,Location);
      numeric   Distance(Location,Location);
   }

   state {
      function  Location PosRobot(Truck);
      function  Location PosObject(Object);
      function  Object   HasWhichObject(Truck);
   }


/************************************
           A c t i o n s 
*************************************/


   action Goto(Truck t, Location orig, Location dest){
       duration:
          constant Distance(orig, dest) / 1.0;
       conditions:
          @start: PosRobot(t) = orig;
          @start: Link(orig, dest);
       effects:
          @end: PosRobot(t) = dest;
   }


   action Load(Truck t, Location p, Object o){
      duration:
         uniform 30 90;
      conditions:
         @overall: PosRobot(t) = p;
         @start: PosObject(o) = p;
         @start: HasWhichObject(t) = undefined;
      effects:
         @end: PosObject(o) = undefined;
         @end: HasWhichObject(t) = o;
   }

   action Unload(Truck t, Location p, Object o){
      duration:
         uniform 30 90;
      conditions:
        @overall: PosRobot(t) = p;
        @start: HasWhichObject(t) = o;
        @start: PosObject(o) = undefined;
      effects:
        @end: PosObject(o) = p;
        @end: HasWhichObject(t) = undefined;
    }

}
